﻿// ******************************************************
// Copyright © 2010 DCOM Productions®, 
// All Rights Reserved
// ******************************************************

namespace BitFlex.EnterpriseServices.Authentication {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Results that are returned when trying to authenticate
    /// </summary>
    public enum AuthenticationResult {
        /// <summary>
        /// An error occurred when trying to authenticate
        /// </summary>
        Error = 0,
        /// <summary>
        /// The incorrect password was supplied
        /// </summary>
        IncorrectPassword = 1,
        /// <summary>
        /// An network error occurred when trying to authenticate
        /// </summary>
        NetworkError = 0,
        /// <summary>
        /// The authentication was successful
        /// </summary>
        Success = 2,
        /// <summary>
        /// The user was not found in the datasource
        /// </summary>
        UserNotFound = 3
    }
}