﻿// ******************************************************
// Copyright © 2010 DCOM Productions®, 
// All Rights Reserved
// ******************************************************

namespace BitFlex.EnterpriseServices.Authentication {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Creates a mapping of a registry key and its associated values
    /// </summary>
    public class RegistryAuthenticationKeyMap {
        /// <summary>
        /// Initializes a new instance of the BitFlex.EnterpriseServices.Authentication.RegistryAuthenticationKeyMap class
        /// </summary>
        public RegistryAuthenticationKeyMap() {
            // Todo: default constructor code
        }

        /// <summary>
        /// Initializes a new instance of the BitFlex.EnterpriseServices.Authentication.RegistryAuthenticationKeyMap class
        /// </summary>
        /// <param name="keyRoot">The full path to the key that stores the registry values</param>
        public RegistryAuthenticationKeyMap(string keyRoot)
            : this() {
            KeyRoot = keyRoot;
        }

        /// <summary>
        /// Gets or sets the full path of the root Registry Key
        /// </summary>
        public string KeyRoot {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the value item that stores the user's name
        /// </summary>
        public string NameValue {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the value item that stores the user's password
        /// </summary>
        public string PasswordValue {
            get;
            set;
        }
    }
}