﻿// ******************************************************
// Copyright © 2010 DCOM Productions®, 
// All Rights Reserved
// ******************************************************

namespace BitFlex.EnterpriseServices.Authentication {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Collections.ObjectModel;

    /// <summary>
    /// Creates a mapping of a Sql table and its associated columns
    /// </summary>
    public class SqlAuthenticationTableMap {
        /// <summary>
        /// Initializes a new instance of the BitFlex.EnterpriseServices.Authentication.SqlAuthenticationTableMap class
        /// </summary>
        public SqlAuthenticationTableMap() {
            // Todo: default constructor code here
        }

        /// <summary>
        /// Initializes a new instance of the BitFlex.EnterpriseServices.Authentication.SqlAuthenticationTableMap class
        /// </summary>
        /// <param name="tableName">The name of the sql table</param>
        public SqlAuthenticationTableMap(string tableName)
            : this() {
            this.TableName = tableName;
        }

        /// <summary>
        /// Gets or sets the name of the column used to store user's names
        /// </summary>
        public string NameColumn {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the column used to store user's passwords
        /// </summary>
        public string PasswordColumn {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the sql table
        /// </summary>
        public string TableName {
            get;
            set;
        }
    }
}
