﻿// *********************************************************************
// [DCOM Productions]
// [Copyright (C) DCOM Productions All rights reserved.]
// *********************************************************************

namespace BitFlex.Win32.Constants {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Application Desktop Toolbar Notifications
    /// </summary>
    /// <remarks>These are put in the wParam of callback messages</remarks>
    public enum ABNotification {
        /// <summary>
        /// Notifies an appbar that the taskbar's autohide or always-on-top state has changed—that is, the user has selected or cleared the "Always on top" or "Auto hide" check box on the taskbar's property sheet.
        /// </summary>
        ABN_STATECHANGE = 0x0000000,

        /// <summary>
        /// Notifies an appbar when an event has occurred that may affect the appbar's size and position. Events include changes in the taskbar's size, position, and visibility state, as well as the addition, removal, or resizing of another appbar on the same side of the screen.
        /// </summary>
        ABN_POSCHANGED = 0x0000001,

        /// <summary>
        /// Notifies an appbar when a full-screen application is opening or closing. This notification is sent in the form of an application-defined message that is set by the ABM_NEW message.
        /// </summary>
        ABN_FULLSCREENAPP = 0x0000002,

        /// <summary>
        /// Notifies an appbar that the user has selected the Cascade, Tile Horizontally, or Tile Vertically command from the taskbar's shortcut menu.
        /// </summary>
        /// <remarks>lParam, TRUE means hide</remarks>
        ABN_WINDOWARRANGE = 0x0000003
    }
}