﻿// *********************************************************************
// [DCOM Productions]
// [Copyright (C) DCOM Productions All rights reserved.]
// *********************************************************************

namespace BitFlex.Win32.Structures {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Runtime.InteropServices;

    /// <summary>
    /// Contains information about a system appbar message. This structure is used with the SHAppBarMessage function.
    /// </summary>
    /// <devdoc>
    ///     <para>
    ///         typedef struct _AppBarData {
    ///           DWORD  cbSize;
    ///           HWND   hWnd;
    ///           UINT   uCallbackMessage;
    ///           UINT   uEdge;
    ///           RECT   rc;
    ///           LPARAM lParam;
    ///         } APPBARDATA, *PAPPBARDATA;
    ///     </para>
    /// </devdoc>
    [StructLayout(LayoutKind.Sequential)]
    public struct APPBARDATA {
        public int cbSize;
        public IntPtr hWnd;
        public uint uCallbackMessage;
        public uint uEdge;
        public RECT rc;
        public bool lParam;
    }
}
