﻿//-----------------------------------------------------------------------------
// <copyright file="MARGINS.cs" company="DCOM Productions">
//     Copyright (c) DCOM Productions.  All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------

namespace BitFlex.Win32.Structures {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Runtime.InteropServices;

    /// <summary>
    /// Returned by the GetThemeMargins function to define the margins of windows that have visual styles applied.
    /// </summary>
    /// <devdoc>
    ///     <para>
    ///         typedef struct _MARGINS {
    ///           int cxLeftWidth;
    ///           int cxRightWidth;
    ///           int cyTopHeight;
    ///           int cyBottomHeight;
    ///         } MARGINS, *PMARGINS
    ///     </para>
    /// </devdoc>
    [StructLayout(LayoutKind.Sequential)]
    public struct MARGINS {
        public int Left;
        public int Right;
        public int Top;
        public int Bottom;
    }
}