﻿// *********************************************************************
// [DCOM Productions]
// [Copyright (C) DCOM Productions All rights reserved.]
// *********************************************************************

namespace BitFlex.Windows.Forms {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Event Arguments for <see cref="Wizard.PageChanging"/>
    /// </summary>
    public class WizardPageChangingEventArgs : System.EventArgs {
        /// <summary>
        /// Initializes a new instance of the BitFlex.Windows.Forms.WizardPageChangedEventArgs class
        /// </summary>
        /// <param name="oldIndex">The old index in the wizard</param>
        /// <param name="newIndex">The new index in the wizard</param>
        public WizardPageChangingEventArgs(int oldIndex, int newIndex)
            : base() {
            m_OldIndex = oldIndex;
            m_NewIndex = newIndex;
        }

        private bool m_Cancel = false;
        /// <summary>
        /// Gets or sets a System.Boolean value indicating whether changing pages should be cancelled
        /// </summary>
        public bool Cancel {
            get {
                return m_Cancel;
            }
            set {
                m_Cancel = value;
            }
        }

        private int m_OldIndex;
        /// <summary>
        /// Gets the old index in the wizard 
        /// </summary>
        public int OldIndex {
            get {
                return m_OldIndex;
            }
        }

        private int m_NewIndex;
        /// <summary>
        /// Gets the new index in the wizard
        /// </summary>
        public int NewIndex {
            get {
                return m_NewIndex;
            }
        }
    }
}