﻿// *********************************************************************
// [DCOM Productions]
// [Copyright (C) DCOM Productions All rights reserved.]
// *********************************************************************

namespace BitFlex {
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Drawing;

    /// <summary>
    /// The default fonts used in Windows Vista and Windows 7
    /// </summary>
    public static class WindowsFonts {
        /// <summary>
        /// Disabled
        /// </summary>
        public static WindowsFont DisabledText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(50, 50, 50); // Gray
                return windowFont;
            }
        }

        /// <summary>
        /// (none)
        /// </summary>
        public static WindowsFont DocumentHeadings {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Calibri", 17.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// (none)
        /// </summary>
        public static WindowsFont DocumentText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Calibri", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Body Text
        /// </summary>
        public static WindowsFont EditableText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Emphasized Text
        /// </summary>
        public static WindowsFont EmphasizedBoldText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Bold, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Emphasized Text
        /// </summary>
        public static WindowsFont EmphasizedItalicText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Italic, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Content View
        /// </summary>
        public static WindowsFont FileName {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 11.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Group Header
        /// </summary>
        public static WindowsFont GroupHeader {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 11.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 102, 204); // Blue
                return windowFont;
            }
        }

        /// <summary>
        /// HyperLinkText
        /// </summary>
        public static WindowsFont Link {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 102, 204); // Blue
                return windowFont;
            }
        }

        /// <summary>
        /// Hot
        /// </summary>
        public static WindowsFont LinksHover {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(51, 153, 255); // LightBlue
                return windowFont;
            }
        }

        /// <summary>
        /// Main Instruction
        /// </summary>
        public static WindowsFont MainInstructions {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 12.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 51, 153); // Blue
                return windowFont;
            }
        }

        /// <summary>
        /// Body Text
        /// </summary>
        public static WindowsFont NormalText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Instruction
        /// </summary>
        public static WindowsFont SecondaryInstructions {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }

        /// <summary>
        /// Caption Font
        /// </summary>
        public static WindowsFont TitleBarText {
            get {
                WindowsFont windowFont = new WindowsFont();
                Font font = new Font("Segoe UI", 9.0F, FontStyle.Regular, GraphicsUnit.Point);
                windowFont.Font = font;
                windowFont.FontColor = Color.FromArgb(0, 0, 0); // Black
                return windowFont;
            }
        }
    }
}